import { ref as g, markRaw as D, shallowReactive as x, defineComponent as A, onUnmounted as V, createElementBlock as p, openBlock as u, Fragment as H, renderList as L, unref as _, createBlock as k, resolveDynamicComponent as S } from "vue";
import { waitWhile as O } from "../utils/system.js";
import { historySetState as v, genHash as y, getHash as P } from "../utils/route.js";
class c {
  static state = {
    load: void 0,
    decoratorOnCreate: void 0,
    /**
     * Порядковай номер перехода в диалоговых окнах
     *
     * Для расчета анимации Вперед / Назад
     */
    viewPageN: 0
  };
  static inited = !1;
  /**
   * Инициировать события слежения за парамтерами url
   *
   * Если в параметрах есть запрос на открытие диалогового окна, TopDialog будет автоматически подключен на страницу
   */
  static init(e) {
    if (this.inited) return;
    this.inited = !0, this.state.load = e == null ? void 0 : e.load, this.state.decoratorOnCreate = e == null ? void 0 : e.decoratorOnCreate;
    const a = (e == null ? void 0 : e.autoInitDelay) ?? 5e3;
    window.addEventListener("hashchange", (i) => {
      this.opendDialogsFromChangeUrl(i.oldURL, i.newURL);
    }), this.opendDialogsFromChangeUrl("", location.href), $(document).on("mousedown", "a[data-to-view]", async (i) => {
      const t = i.target.closest("[data-to-view]");
      let s = "next";
      t.dataset.action === "top-dialog-close" && (s = "prev"), t.href = c.genViewPageHash(t.dataset.toView, s);
    }), $(document).on("click", "[data-to-view]", async (i) => {
      const t = i.target.closest("[data-to-view]");
      if (t.href === ".") {
        i.preventDefault(), t.mousedown(), setTimeout(() => t.click());
        return;
      }
      const s = await this.getDialogsUtils(), o = t.dataset.toView, r = o.split("-")[0], d = $("#" + r), f = $("> .modal-layer", d), m = $("> .active", f), N = !!d.data("data-to-view-replace");
      let h = "next";
      if (m.length) {
        const U = o.split("-")[1].split(":")[0];
        $('> [data-view-page="' + U + '"]', f).data("order") < m.data("order") && (h = "prev");
      }
      t.dataset.action === "top-dialog-close" && (h = "prev");
      const w = c.genViewPageHash(o, h);
      if (t.tagName === "A") {
        if (!d.is(":visible")) return;
        if (location.hash.indexOf(o.replace("-", "=")) !== -1) {
          await s.toViewDirty(o);
          return;
        }
      }
      N ? (i.preventDefault(), v(!0, w), await s.toViewDirty(o), h == "next" ? c.state.viewPageN++ : c.state.viewPageN--) : t.tagName !== "A" && (this.compareStates(w, location.hash) ? v(!1, w) : await s.toViewDirty(o));
    }), setTimeout(() => this.getDialogsUtils(), a);
  }
  static opendDialogsFromChangeUrl(e, a) {
    const i = e.replace(/.*?#/, "#"), t = a.replace(/.*?#/, "#");
    this.compareStates(i, t) && this.opendDialogsFromUrl();
  }
  static async getDialogsUtils() {
    const { TopDialogUtils: e } = await import("./utils-CKggUvLI.es.js");
    return e;
  }
  static get$dialog(e) {
    return e.closest(".ui-dialog-content");
  }
  static get$page(e) {
    return e.closest("[data-view-page]");
  }
  /**
   * Получить элементы страницы в шапке и в контенте
   */
  static get$pairPage(e) {
    const a = c.get$dialog(e), t = c.get$page(e).data("view-page");
    return $('[data-view-page="' + t + '"]', a);
  }
  /**
   * Закрыть диалоговое окно
   */
  static close(e) {
    const a = $("#" + e);
    a.dialog("instance") && a.dialog("close");
  }
  /**
   * Размонтировать $.dialog
   */
  static destroy(e) {
    const a = $("#" + e);
    a.dialog("instance") && (a.dialog("close"), a.dialog("destroy"));
  }
  /**
   * Сгенерировать ссылку на страницу в диалоговом окне
   * @param toView - указатель в формате: dialog_{{ dialogId }}={{ pageName }}:{{ args }}
   * @param moveDirection
   */
  static genViewPageHash(e, a = "next") {
    let i = this.state.viewPageN;
    a == "prev" ? i-- : i++;
    const t = e.split("-"), s = t.shift(), o = t.join("-");
    let r = y("vpn", i);
    return r = y("view-" + s, o, r), r;
  }
  /**
   * Сравнить версию открытых диалоговых окон
   * @returns вернет true, если состояния открытых окон изменилось
   */
  static compareStates(e, a) {
    const i = e.match(/[#&]view-[^&]+/g) || [], t = a.match(/[#&]view-[^&]+/g) || [];
    return !!(i.length !== t.length || i.filter((o, r) => {
      const d = t[r] || "";
      return o !== d;
    }).length);
  }
  static opendDialogsFromUrl = async () => {
    const e = Number(P("vpn")) || 0;
    let a;
    const i = new RegExp("view-((\\w+)=([\\w-]+)(?::([\\w.:-]+))?)", "g");
    for (; a = i.exec(location.hash); ) {
      let t = "next";
      return e < this.state.viewPageN && (t = "prev"), (await this.getDialogsUtils()).toViewDirty(a[1], t);
    }
    return $(".ui-dialog-content[data-view-page-active]:visible").each((t, s) => {
      const o = $(s), r = o.attr("id");
      P("view-" + r) || o.dialog("close");
    }), this.state.viewPageN = e, !0;
  };
}
class C {
  /**
   * Индентификатор, определяется на уровне компонента TopDialogComponent
   *
   * Может использоваться в навигации для открытия нужных окон с нужными настройками
   */
  id;
  /**
   * ID, используемый в верстке диалогового окна
   */
  idAttr;
  /**
   * Пользовательский компонент диалогового окна
   */
  Component;
  /**
   * Компонент инициирован
   *
   * Устанавливается после первого вызова useTopDialog()
   */
  isMounted = g(!1);
  /**
   * Компонент готов к использованию
   *
   * Используется для внутренних преобразований после отрисовки
   */
  isReady = g(!1);
  /**
   * Диалоговое окно открыто
   */
  isOpened = g(!1);
  /**
   * Имя активной страницы дилогового окна
   */
  pageActive = g("");
  /**
   * Диалоговое окно находится в состоянии загрузки своей страницы
   */
  isLoadingPage = g(!1);
  /**
   * Следующая активная страница
   *
   * В один момент времени может потребоваться отобразить две страницы, чтобы воспроизвести анимацию
   */
  pageActiveNext = g("");
  /**
   * props компонента, доступны после инициализации
   */
  props;
  /**
   * emit базового компонента `TopDialog`
   */
  emit;
  /**
   * Одноразовое событие на закрытие диалогового окна
   *
   * Используется для привязки окна к сценариям использования
   */
  onCloseOnce;
  constructor(e) {
    this.id = e.id, this.idAttr = "dialog_" + e.id, this.Component = D(e);
  }
  /**
   * Событие - компонент инициирован
   */
  onMounted(e, a) {
    this.isMounted.value = !0, this.props = e.props, this.emit = a.emit;
  }
  /**
   * Открыть диалоговое окно
   *
   * Учтите, что props в диалоговом окне будут доступны не сразу, а только после инициализации vue компонента
   */
  async open(e = "main", a, i = [], t, s) {
    a && await this.setProps(a), t && (this.onCloseOnce = t), await (await c.getDialogsUtils()).toView(this.idAttr, e, i, s);
  }
  /**
   * Открыть диалоговое окно как ссылку, для хеш-навигации
   *
   * Диалоговые окна загружаются по имени, см. настройку плагина Core topDialogLoader
   */
  async openAsLink(e = "main", a, i = [], t, s) {
    a && await this.setProps(a), t && (this.onCloseOnce = t);
    const o = this.idAttr + "-" + e, r = c.genViewPageHash(o, s);
    v(!1, r);
  }
  /**
   * Закрыть диалоговое окно
   *
   * Не меняет состояние компонента диалогового окна
   */
  async close() {
    c.close(this.idAttr);
  }
  /**
   * Размонтировать $.dialog
   */
  async destroy() {
    c.destroy(this.idAttr);
  }
  /**
   * Устанвоить props
   *
   * Полностью сбрасывается состояние props
   */
  async setProps(e = {}) {
    this.isMounted || await O(() => !this.props);
    for (const a in this.props)
      this.props[a] = e[a];
  }
  /**
   * Проверить, есть ли необходимость отрисовки страницы диалогового окна
   */
  needShowPage(e) {
    return this.isOpened.value ? this.pageActive.value === e || this.pageActiveNext.value === e : !1;
  }
}
const E = {
  class: "top-dialogs",
  style: { display: "none" }
}, l = x(/* @__PURE__ */ new Map()), B = (n) => (n = n.replace(/^dialog_/, ""), l.get(n)), I = (n) => {
  if (!(n != null && n.id))
    throw console.log({ TopDialogComponent: n }), new Error("Expected TopDialogComponent");
  return l.has(n.id) || l.set(n.id, new C(n)), l.get(n.id);
}, j = /* @__PURE__ */ A({
  name: "DialogWrapper",
  __name: "dialogs",
  setup(n) {
    return V(() => {
      l.forEach((e) => e.destroy()), l.clear();
    }), (e, a) => (u(), p("div", E, [
      (u(!0), p(H, null, L(_(l), ([i, t]) => (u(), k(S(t.Component), { key: i }))), 128))
    ]));
  }
});
export {
  c as T,
  j as _,
  I as a,
  B as g
};
//# sourceMappingURL=dialogs.vue_vue_type_script_setup_true_lang-JyillkBh.es.js.map
