import { u as w, C as f } from "./forms-zDpk9gMK.es.js";
import i from "../utils/dom.js";
import { TopPopupWorker as s } from "../popup/worker.js";
class x {
  static componentName = "Top";
  componentName;
  // имя класса компонента
  className;
  // имя css класса компонента
  uid;
  // уникальный id компонента
  el;
  // элемент, связанный с компонентом
  options = {};
  // параметры компонента
  unmountEls = [];
  unmountEvents = [];
  // переопредлять нельзя
  // если компонент инициирован, необходимо сразу его вернуть и выполнить reInit() вместо mount()
  // используется init вместо constructor, так как super constructor выполняется до Object.defineProperty() параметров класса
  init(t, p, o) {
    if (!p)
      throw t + ": el is undefined";
    const e = x.getComponent(p, t);
    if (e)
      return e.reInit(o), e;
    this.componentName = t, this.className = "top" + t[0].toUpperCase() + t.substring(1), this.uid = this.componentName + (Math.random() + "").replace(".", ""), this._setComponent(p), this.el = p, this.el.classList.add(this.className), this.options = Object.assign(this.options, o), this.mount();
  }
  // получить инициированный компонент
  static getComponent(t, p) {
    return i.storage(t, "#" + p);
  }
  // устанвоить компонент
  _setComponent(t) {
    i.storage(t, "#" + this.componentName, this);
  }
  // функция подключения компонента
  mount() {
    throw "Please, add method mount() to component: " + this.componentName;
  }
  // функция отключения компонента
  unmount() {
    i.storage(this.el, "#" + this.componentName, null), this.unmountEls.forEach((t) => {
      t.remove();
    }), this.unmountEls = [], this.unmountEvents.forEach((t) => {
      t.el.removeEventListener(t.type, t.listener, t.options);
    }), this.unmountEvents = [];
  }
  // указание новые элементы, которые должны будут удалиться после unmount
  registerElForUnmount(t) {
    this.unmountEls.push(t);
  }
  // указание новые события, которые должны будут удалиться после unmount
  addEventListenerWithUnmount(t, p, o, e) {
    t.addEventListener(p, o, e), this.registerEventForUnmount(t, p, o, e);
  }
  // указание новые события, которые должны будут удалиться после unmount
  registerEventForUnmount(t, p, o, e) {
    const n = {
      el: t,
      type: p,
      listener: o,
      options: e
    };
    this.unmountEvents.push(n);
  }
  // функция перенастройки уже подключенного компонента
  reInit(t) {
    throw "Please, add method reInit() to component: " + this.componentName;
  }
  // удалить элементы из DOM, но не из памяти
  static detach(t) {
    var p;
    if (t instanceof NodeList)
      t.forEach((o) => {
        var e;
        return (e = o.parentElement) == null ? void 0 : e.removeChild(o);
      });
    else {
      const o = t;
      (p = o.parentElement) == null || p.removeChild(o);
    }
  }
}
class y {
  static isInited = !1;
  /**
   * Добавить глобальные обработчики
   *
   * Добавляются на страницу один раз и навсегда
   */
  static init() {
    this.isInited || (this.isInited = !0, document.addEventListener("click", this.onclickCapture, { capture: !0 }), document.addEventListener("click", this.onclick), document.addEventListener("keydown", this.onkeydown));
  }
  /**
   * Глобальный обработчик захватов кликов
   *
   * Обрабатывает захватов клики внутри Popup
   */
  static onclickCapture(t) {
    var o;
    if (!(!(t.target instanceof HTMLElement) || !t.target.closest(".top-popup-wrapper"))) {
      if (t.target.matches("[data-top-popup]")) {
        const e = t.target.closest("ul"), n = t.target.closest("a, .a");
        e && ((o = e.querySelector("a.top-active, .a.top-active")) == null || o.classList.remove("top-active")), n && n.classList.add("top-active"), t.stopPropagation();
        return;
      }
      if (t.target.matches(".top-popup-wrapper")) {
        const e = t.target;
        s.close(e), t.stopPropagation();
        return;
      }
    }
  }
  /**
   * Глобальный обработчик кликов
   *
   * Обрабатывает клики внутри Popup
   */
  static onclick(t) {
    if (!(t.target instanceof HTMLElement)) return;
    const p = t.target.closest(".closer, a, .a, .top-button");
    if (p) {
      const o = t.target.closest(".top-popup-wrapper");
      if (!o || p.matches(".top-popup-noCloser"))
        return;
      p.getAttribute("href") === "." && t.preventDefault(), s.close(o);
    }
  }
  /**
   * Глобальный обработчик нажатия кнопки на клавиатуре
   */
  static onkeydown(t) {
    var e, n;
    if (!(t.target instanceof HTMLElement)) return;
    const p = t.target.closest(".top-popup-wrapper");
    if (!p)
      return;
    const o = p.querySelector("ul.top-popup_content");
    switch (t.key) {
      case "Escape":
        s.close(p);
        break;
      case "Enter":
        if (!o) {
          if (i.querySelectorVisible(p, ".preloader"))
            break;
          const u = i.querySelectorVisible(p, ".top-popup_footer .go, .top-popup_footer [data-action]");
          if (u instanceof HTMLElement) {
            u.click();
            break;
          }
          let m = i.querySelectorVisibleLast(p, ".top-popup_footer .top-button:focus");
          m || (m = i.querySelectorVisibleLast(p, ".top-popup_footer .top-button")), m instanceof HTMLElement && m.click();
          break;
        }
        const r = i.querySelectorVisible(p, "li > a.top-active");
        r && r.getAttribute("href") && (t.preventDefault(), location.href = r.getAttribute("href"));
        const a = p.querySelector("li > .top-active");
        a instanceof HTMLElement && a.click();
        break;
      // управление стрелками
      case "ArrowUp":
      case "ArrowRight":
      case "ArrowDown":
      case "ArrowLeft":
        if (!o)
          break;
        t.key === "ArrowRight" || t.key === "ArrowLeft" ? i.querySelectorVisible(
          p,
          "ul.top-popup_content > li:not(.top-popup_liNoSelectable) > .top-active > .top-popup_listMore"
        ) && t.preventDefault() : t.preventDefault();
        const c = (e = p.querySelector("ul.top-popup_content > li:not(.top-popup_liNoSelectable) > .top-active")) == null ? void 0 : e.parentElement;
        if (t.key === "ArrowRight" && c) {
          const u = c.querySelector(".top-active > .top-popup_listMore");
          if (u instanceof HTMLElement)
            return u.click();
        }
        const h = i.querySelectorAllVisible(p, "ul.top-popup_content > li:not(.top-popup_liNoSelectable)"), d = h.length;
        if (!d)
          return;
        let l = -1;
        if (c && (l = h.indexOf(c)), t.key === "ArrowUp" || t.key === "ArrowLeft" ? l-- : l++, t.key === "ArrowLeft" && l === -1)
          return t.target.matches("input") ? void 0 : s.close(p);
        if (t.key === "ArrowRight" && l === d)
          return;
        l < 0 && (l = d - 1), l > d - 1 && (l = 0), p.querySelectorAll("ul.top-popup_content > li > .top-active").forEach((u) => u.classList.remove("top-active")), (n = h[l].querySelector(":scope > a, :scope > .a")) == null || n.classList.add("top-active"), s.scrollToActive(p);
        break;
    }
  }
}
const _ = ":root{--top-popup-z-index: 200000;--top-popup-transition-delay: .1s;--top-popup-background-color: var(--color-layout-front-1);--top-popup-background-color-hover: var(--color-layout-front-3);--top-popup-background-color-active: var(--color-layout-front-4);--top-popup-border-color: var(--color-line-2-opacity);--top-popup-title-background-color: var(--color-layer-1);--top-popup-content-padding: calc(var(--top-popup-list-padding) + var(--top-popup-listItem-padding));--top-popup-list-padding: var(--top-padding-2);--top-popup-listItem-radius: var(--top-radius-2);--top-popup-listItem-padding: var(--top-padding-2)}.top-popup-front{position:relative}.top-popup-wrapper{--top-popup-height: 0px;--top-popup-right-bounding: 0px;--top-popup-bottom-bounding: 0px;--top-popup-top: 0px;--top-popup-right: calc(100vw - var(--top-popup-right-bounding));--top-popup-bottom: calc(var(--100vh) - var(--top-popup-bottom-bounding));--top-popup-left: 0px;text-align:initial;white-space:normal;word-break:normal;position:absolute;z-index:200000}.top-popup-wrapper:not(.top-popup-wrapper-shown){overflow:hidden}.top-popupPanel{cursor:default;box-shadow:var(--top-shadow-b);border-radius:14px;background:var(--top-popup-background-color);position:absolute;overflow:hidden;display:flex;flex-direction:column}.top-popup-wrapper>*{opacity:0;transition:opacity var(--top-popup-transition-delay) linear,transform var(--top-popup-transition-delay) linear}.top-popup-wrapper.p0>*{transform:translateY(-8px)}.top-popup-wrapper.p1>*{transform:translateY(8px)}.top-popup-wrapper.p2>*{transform:translate(8px)}.top-popup-wrapper.p3>*{transform:translateY(8px)}.top-popup-wrapper.p4>*{transform:translate(-8px)}.top-popup-wrapper-shown:not(.top-popup-wrapper-closed)>*{opacity:1;transform:translate(0)!important}.top-popup-wrapper.p0>.top-popup{top:-16px;left:-8px}.top-popup-wrapper.p1>.top-popup{bottom:calc(100% + 8px)}.top-popup-wrapper.p2>.top-popup{left:calc(100% + 8px)}.top-popup-wrapper.p3>.top-popup{top:calc(100% + 8px)}.top-popup-wrapper.p4>.top-popup{right:calc(100% + 8px)}.top-popup-wrapper.p2>.top-popup,.top-popup-wrapper.p4>.top-popup{margin-top:-10px}.top-popup-wrapper.p2.invert-y>.top-popup,.top-popup-wrapper.p4.invert-y>.top-popup{margin-bottom:-10px}.top-popup-wrapper.p1.with_notch>.top-popup{margin-bottom:5px}.top-popup-wrapper.p2.with_notch>.top-popup{margin-left:5px}.top-popup-wrapper.p3.with_notch>.top-popup{margin-top:5px}.top-popup-wrapper.p4.with_notch>.top-popup{margin-right:5px}.top-popup-wrapper.invert-x>.top-popup{right:0}.top-popup-wrapper.invert-y>.top-popup{bottom:0}.top-popup-wrapper>.notch{border:7.4px solid transparent;position:absolute;display:block}.top-popup-wrapper.p1>.notch{border-bottom:0;border-top:7.4px solid var(--color-layout-front-1);margin:0 0 7.4px -7.4px;bottom:100%;left:50%}.top-popup-wrapper.p2>.notch{border-left:0;border-right:7.4px solid var(--color-layout-front-1);margin:0 0 -7.4px 7.4px;bottom:50%;left:100%}.top-popup-wrapper.p3>.notch{border-top:0;border-bottom:7.4px solid var(--color-layout-front-1);margin:7.4px 0 0 -7.4px;top:100%;left:50%}.top-popup-wrapper.p4>.notch{border-right:0;border-left:7.4px solid var(--color-layout-front-1);margin:0 7.4px -7.4px 0;bottom:50%;right:100%}.top-popup-wrapper.p1>.notch-border{border-top-color:#0000000d;margin-bottom:6px}.top-popup-wrapper.p2>.notch-border{border-right-color:#0000000d;margin-left:6px}.top-popup-wrapper.p3>.notch-border{border-bottom-color:#0000000d;margin-top:6px}.top-popup-wrapper.p4>.notch-border{border-left-color:#0000000d;margin-right:6px}.top-popup_header,.top-popup_content,.top-popup_footer{font-size:14px}.top-popup_header,.top-popup_footer{display:flex;align-items:center;justify-content:space-between}.top-popup_header{color:var(--color-text-1);border-bottom:1px solid var(--top-popup-border-color);padding:var(--top-padding-3);font-weight:600}.top-popup_header>*{font-weight:400}.top-popup_header>.a{cursor:pointer}.top-popup_header>.a:hover{color:var(--color-text-primary)}.top-popup_headerButton{width:60px}.top-popup_widget{padding:var(--top-padding-2)}.top-popup_content{margin:0;flex-grow:1;overflow-y:auto;display:flex;flex-direction:column;gap:var(--top-gap-4);-webkit-overflow-scrolling:touch}div.top-popup_content{color:var(--color-text-1);padding:var(--top-popup-content-padding)}div.top-popup_content>*{flex-shrink:0}div.top-popup_content>.top-button{margin:0}div.top-popup_content .top-unwrap{--top-unwrap-x: var(--top-popup-content-padding)}ul.top-popup_content{color:var(--color-text-1);padding:var(--top-popup-list-padding);gap:2px}ul.top-popup_content .top-unwrap{--top-unwrap-x: var(--top-popup-list-padding)}.top-popup_listItem{border-radius:var(--top-popup-listItem-radius);padding:var(--top-popup-listItem-padding);line-height:1!important}ul.top-popup_content li{margin:0;list-style:none;display:flex;position:relative}ul.top-popup_content li>*{flex-grow:1}ul.top-popup_content li>a:not(.top-button),ul.top-popup_content li>.a{cursor:pointer;box-sizing:border-box;border-radius:var(--top-popup-listItem-radius);background:var(--top-popup-background-color);padding:var(--top-popup-listItem-padding);color:var(--color-text-1)!important;font-size:14px;font-weight:400!important;text-decoration:none!important;font-style:normal;line-height:1!important;display:flex;flex:1 1 100%;align-items:center;transition:background-color .1s ease-in-out}.top-popup-wrapper-no_animate ul.top-popup_content li>a:not(.top-button),.top-popup-wrapper-no_animate ul.top-popup_content li>.a{transition:none}ul.top-popup_content li>a:not(.top-button):hover,ul.top-popup_content li>.a:hover{background:var(--top-popup-background-color-hover)}ul.top-popup_content li>a:not(.top-button).top-active,ul.top-popup_content li>.a.top-active{--top-icon-color: var(--color-text-primary) !important;background:var(--top-popup-background-color-active)}.top-popup_content+.top-popup_content{padding-top:0}.top-popup_listItem-title{background:var(--color-layer-1);color:var(--color-text-1);font-size:12px}.top-popup_listItem-delimiter{border-radius:3px;background:var(--top-popup-border-color);height:1px;padding:0;margin:4px}.top-popup_listMore{font-size:20px;margin:calc(0px - var(--top-popup-listItem-padding)) calc(0px - var(--top-popup-listItem-padding) / 2) calc(0px - var(--top-popup-listItem-padding)) 0}.top-popup_listMore.top-button{margin:0}ul.top-popup_content li>.a.top-popup_listMore{text-align:center;flex-basis:10px}ul.top-popup_content li>.a.top-popup_listMore:before{color:var(--color-text-2)}ul.top-popup_content li>*>.top-popup_listMore{margin-left:auto;color:var(--color-layer-4);font-size:14px}ul.top-popup_content li>*>i.top-popup_listMore:hover,ul.top-popup_content li>*>i.top-popup_listMore.top-active{color:var(--color-text-primary)}ul.top-popup_content li>*>i.top-popup_listMore:before{transform:rotate(90deg);display:block}ul.top-popup_content li a.close{background:none!important}.top-popup_content>[data-top-icon]:before{--top-icon-size: 20px}ul.top-popup_content li>[data-top-icon]:not(.top-button){--top-icon-color: var(--color-text-3);--top-icon-size: 20px;--top-icon-width: 20px}ul.top-popup_content li>[data-top-icon]:not(.top-button):before{height:1rem;margin-right:8px;transition:color .1s}ul.top-popup_content li:hover>[data-top-icon]:not(.top-button){--top-icon-color: var(--color-text-2)}.top-popup_footer{padding:var(--top-padding-3);border-top:1px solid var(--top-popup-border-color);display:flex;gap:var(--top-gap-2);justify-content:flex-end}.top-popup_footerSupportLink{margin-right:auto}.top-popup>[data-widget]{padding:0 var(--top-popup-list-padding)}.top-popup>[data-widget]+hr{margin:0 var(--top-popup-list-padding)}.top-popup .placeholder{border:1px solid #E0D9D9!important;border-right:none!important;border-left:none!important;background:#f9f9f9!important;margin:-1px 0;z-index:1;position:relative}.top-popup-wrapper.simple_list>.top-popup{min-width:0;white-space:nowrap}.top-popup_content .top-column{display:flex;flex-direction:column;gap:4px}html .top-popup .top-popup_content li>.top-button{margin:calc(var(--top-popup-listItem-padding) / 2) var(--top-popup-listItem-padding)}.top-popup li .check_all,.top-popup li .clear_all{cursor:pointer;color:var(--color-text-primary);padding:8px;display:inline-block}.top-popup li .check_all:hover,.top-popup li .clear_all:hover{text-decoration:underline}.top-popup li .clear_all{display:none}.top-popup_content table{margin:-9px 0}.top-popup_content table td,.top-popup_content table th{padding:9px var(--top-popup-listItem-padding) 9px 0;vertical-align:top}.top-popup_content table th{width:40%;font-weight:600;white-space:nowrap}ul.top-popup_content .a>[type=checkbox],ul.top-popup_content .a>[type=radio]{margin:-8px 0 -8px auto}ul.top-popup_content a>[class*=icon],ul.top-popup_content i.a>[class*=icon]{transition:.1s}.top-popup .buttons{border-radius:0 0 4px 4px;border-top:1px solid #BDC3C7;background:#ecf0f1;padding:10px 15px;margin:10px -15px -10px;white-space:nowrap}.top-popup_footer [class*=btn]:not(.btn-transparent){min-width:100px;padding:5px 14px;margin-left:10px}.top-popup_footer [class*=btn]:first-child{margin-left:0}.top-popup_footer .btn.full_width{margin:0;flex-grow:1}", L = ":root{--top-popup-list-padding: 0px;--top-popup-listItem-radius: 0px;--top-popup-listItem-padding: var(--top-padding-4)}html.with_popup{background:gray}.top-popup-wrapper{--top-popup-footer-offset: 25px;width:auto!important;height:auto!important;position:fixed;top:0!important;right:0!important;left:0!important;overflow:hidden;transition:background .3s}.top-popup-wrapper-shown:not(.top-popup-wrapper-closed){background:#00000080;-webkit-backdrop-filter:blur(1px);backdrop-filter:blur(1px)}.top-popup-wrapper-shown:not(.top-popup-wrapper-closed)>.top-popup{opacity:1!important}.top-popup{border-radius:8px 8px 0 0;width:auto!important;max-height:calc(100% - var(--header-height, 0px) - var(--toolbar-height, 0px) - 12px);margin:0!important;top:auto!important;right:0!important;bottom:var(--toolbar-height, 0px)!important;left:0!important;display:flex;flex-direction:column;transform:translateY(80%);transition:opacity .3s,transform .3s}.top-popup-wrapper.p-from-top{--top-popup-footer-offset: 0px;top:var(--header-height, 0px)!important}.with_dialog .top-popup-wrapper.p-from-top{top:50px!important}.top-popup-wrapper.p-from-top>.top-popup{border-radius:0 0 8px 8px;max-height:calc(100% - 24px);top:0!important;bottom:auto!important;transform:translateY(calc(-100% - 24px))}.top-popup_widget:not(.p-from-top){order:10}ul.top-popup_content{gap:0}ul.top-popup_content li:not(:last-child){border-bottom:1px solid var(--top-popup-border-color)}.top-popup-wrapper.top-style_alt>.top-popup>ul>li{border-bottom:none}.top-popup_footer{flex-direction:column-reverse}.top-popup_footer>.top-button{--top-forms-base-height: var(--top-forms-base-height_l);width:100%}ul.top-popup_content .top-popup_listItem-title{--top-popup-padding-v: 12px}ul.top-popup_content .top-popup_listItem-delimiter{background:var(--color-line-1-opacity);height:4px;margin:0}ul.top-popup_content li:first-child>.top-popup_listItem-delimiter{border-top:1px solid var(--top-popup-border-color)}", E = ".top-popup{min-width:250px;max-width:calc(100vw - var(--top-popup-left) - 16px);max-height:calc(var(--top-popup-bottom) + var(--top-popup-height))}.top-popup-wrapper.invert-x>.top-popup{max-width:calc(100vw - var(--top-popup-right) - 16px)}.top-popup-wrapper.invert-y>.top-popup{max-height:calc(100vh - var(--top-popup-bottom) - 16px)}.top-popup-wrapper.p1>.top-popup{max-height:calc(var(--top-popup-top) - var(--header-height, 0px) - 16px)}.top-popup-wrapper.p3>.top-popup{max-height:calc(var(--top-popup-bottom) - 16px)}.top-popup-wrapper.p2>.top-popup{max-width:calc(var(--top-popup-right) - 16px)}.top-popup-wrapper.p4>.top-popup{max-width:calc(var(--top-popup-left) - 16px)}.top-popup-wrapper.p1.with_notch>.top-popup,.top-popup-wrapper.p3.with_notch>.top-popup{margin-left:-16px!important}.top-popup-wrapper.p1.with_notch>.notch,.top-popup-wrapper.p3.with_notch>.notch{margin-left:-8px!important}.top-popup-wrapper.p1.with_notch.invert-x,.top-popup-wrapper.p3.with_notch.invert-x{margin-left:3px!important}.top-popup-wrapper.p1.with_notch.invert-x>.notch,.top-popup-wrapper.p3.with_notch.invert-x>.notch{margin-left:-9px!important}ul.top-popup_content li>*>i.top-popup_listMore{visibility:hidden;transition:none}ul.top-popup_content li:hover>*>i.top-popup_listMore,ul.top-popup_content li>*.top-active>i.top-popup_listMore,ul.top-popup_content li>*>i.top-popup_listMore.top-active{visibility:visible}";
f.insertStyleToPage(_);
f.insertStyleToPage(L, "m");
f.insertStyleToPage(E, "pc");
class v extends x {
  static componentName = "TopPopup";
  // элемент, вызвавший открытие Popup
  elActiveByDefault;
  // элемент уже имеет класс top-active перед открытием окна
  elPopup;
  // Popup .top-popup-wrapper
  elPopupInner;
  // контентная часть Popup  .top-popup
  elPopupHeader;
  elPopupWidget;
  elPopupBody;
  elPopupFooter;
  elFront;
  popupParent;
  $;
  // только, если есть jQuery
  elStartPosition;
  // используется для useOriginal
  shift = {
    top: 0,
    left: 0
  };
  isClosed = !1;
  // флаг того, что меню закрыто
  isFirstClick = !0;
  type;
  // selector или html
  options = {
    popup: "",
    // selector, text
    p: 0,
    // положение меню (0 - над элементом, 1 - сверху, 2 - справа, 3 - снизу, 4 слева)
    notch: !1,
    // отображать ли клювик
    class: "",
    // класс, добавляемый меню
    posBy: "left",
    // способ привязки позиционирования меню (left/right - левый/правый край родителя, fixed - по документу)
    frontSelector: "",
    invertX: !1,
    // базовая ордината - правая граница элемента, а не левая
    openByHover: !1,
    // открывать при наведении
    useOriginal: !1,
    // использовать оригинальный шаблон, без клонирвоания (для сохранения состояния меню)
    transitionDuration: 100,
    // значение прописано в css
    isFullScreen: !1
  };
  events = {};
  /**
   * Создать Popup
   * @param el - элемент, открывающий меню
   * @param options
   */
  constructor(t, p) {
    super(), this.init(v.componentName, t, p);
  }
  async mount() {
    var e, n;
    if (!(this.el instanceof HTMLElement)) return;
    const t = this.vueGetComponent();
    if (this.el.closest(".top-popup-wrapper") && (this.popupParent = s.getPopup(this.el.closest(".top-popup-wrapper"))), await this.mountJQuery(), i.css(this.el, "position") !== "absolute" && (this.el.style.position = "relative"), this.el.dataset.topPopupOpened = "opened", this.elActiveByDefault = this.el.classList.contains("top-active"), this.el.classList.add("top-active"), t)
      this.type = "vue", this.options.popup = "", this.elPopup = i.genEl("div", {}, this.options.popup);
    else if ((e = this.options.popup) != null && e.match(/^[#.]/))
      this.type = "selector", this.elPopup = document.querySelector(`${this.options.popup}.template`) || void 0;
    else {
      if (this.type = "html", this.options.useOriginal)
        throw "Option useOriginal not allowed for text templates";
      this.elPopup = i.genEl("div", {}, this.options.popup ?? "");
    }
    if (!this.elPopup || t != null && t.opened) {
      if (this.options.useOriginal || t != null && t.opened) {
        if (t != null && t.opened ? this.elPopup = t.popup.elPopup : this.elPopup = document.querySelector(`${this.options.popup}.top-popup-wrapper-shown`) || void 0, this.elPopup) {
          this.el.dataset.topPopupOpened = "", this.elActiveByDefault || this.el.classList.remove("top-active"), s.close(this.elPopup), setTimeout(() => this.mount(), this.options.transitionDuration);
          return;
        }
        throw "Option useOriginal state allowed only elements .template";
      }
      this.elPopup = document.querySelector(`${this.options.popup}:not(.top-popup-wrapper)`) || void 0;
    }
    if (!this.elPopup)
      return;
    for (this.options.useOriginal ? (this.elStartPosition = this.elPopup.closest(".top-popup-el-start-position"), this.elStartPosition || (this.elStartPosition = i.wrap(this.elPopup, "i"), this.elStartPosition.classList.add("top-popup-el-start-position", "hidden"))) : (this.elPopup = this.elPopup.cloneNode(!0), this.type === "selector" && !this.elPopup.matches(".template") && (this.elPopup.classList.remove("hidden"), this.elPopup.querySelector(":scope > .top-popup_content") || this.elPopup.classList.add("top-popup_content"), this.elPopup = i.wrap(this.elPopup, "div")), this.type === "html" && (this.elPopup.querySelector(":scope > .top-popup_content") || (this.elPopup.classList.add("top-popup_content"), this.elPopup = i.wrap(this.elPopup, "div"))), (this.type === "selector" && !this.elPopup.matches(".template") || this.type === "html" || this.type === "vue") && (i.querySelectorAllArray(this.elPopup, "[data-top-popup]").forEach((r) => {
      r instanceof HTMLElement && (r.dataset.topPopupPosBy = "fixed");
    }), i.querySelectorAllArray(this.elPopup, ".top-popup-wrapper").forEach((r) => r.remove()))), s.decoratorBeforeOpen(this), t && (this.options.class = t.classRef.value, t.transitionDurationRef.value !== void 0 && (this.options.transitionDuration = t.transitionDurationRef.value, this.elPopup instanceof HTMLElement && this.elPopup.style.setProperty(
      "--top-popup-transition-delay",
      this.options.transitionDuration + "ms"
    ))), this.elPopupInner = document.createElement("div"), this.elPopupInner.classList.add("top-popupPanel", "top-popup"); this.elPopup.firstChild; )
      this.elPopupInner.appendChild(this.elPopup.firstChild);
    if (this.elPopup.append(this.elPopupInner), this.elPopup.classList.add("top-popup-wrapper"), this.options.class) {
      const r = this.options.class.split(" ");
      this.elPopup.classList.add(...r);
    }
    this.options.notch && (this.elPopup.classList.add("with_notch"), this.elPopup.insertAdjacentHTML("beforeend", '<i class="notch notch-border"></i><i class="notch"></i>')), await this.vueOpen(), this.elPopupHeader = this.elPopupInner.querySelector(".top-popup_header"), this.elPopupWidget = this.elPopupInner.querySelector(".top-popup_widget"), this.elPopupBody = this.elPopupInner.querySelector(".top-popup_content"), this.elPopupFooter = this.elPopupInner.querySelector(".top-popup_footer");
    const p = !!this.elPopup.querySelector('[data-widget="search"]');
    if (this.options.isFullScreen && !p) {
      const r = w();
      !this.elPopupHeader && r.Common.Close && (this.elPopupHeader = i.genEl("i", { class: "top-popup_header" }), this.elPopupInner.prepend(this.elPopupHeader), this.elPopupHeader.prepend(i.genEl("i", { class: "a closer" }, r.Common.Close)), this.elPopupHeader.append(i.genEl("i", { class: "top-popup_headerButton" })));
    }
    i.storage(this.elPopup, v.componentName, this), this.options.frontSelector && (this.elFront = document.querySelector(this.options.frontSelector)), this.elFront || (this.elFront = this.el.closest(".top-popup-front")), this.elFront || (this.elFront = document.body), this.elPopup instanceof HTMLElement && (this.elPopup.style.width = this.el.offsetWidth + "px", this.elPopup.style.height = this.el.offsetHeight + "px", this.elPopup.style.top = this.el.offsetTop + "px", this.elPopup.style.right = parseInt(this.el.style.right || "0") + "px", this.elPopup.style.bottom = parseInt(this.el.style.bottom || "0") + "px"), (n = this.el.parentElement) == null || n.insertBefore(this.elPopup, this.el), this.elPopup.classList.remove("template"), this.options.invertX && this.elPopup.classList.add("invert-x");
    let o = !!this.el.closest(".modal-header");
    o || (o = !!this.el.closest("#top_panel")), o || (o = !!this.el.closest("#secondmenu")), o && this.elPopup.classList.add("p-from-top"), setTimeout(() => {
      var r;
      return (r = this.elPopup) == null ? void 0 : r.classList.add("top-popup-wrapper-shown");
    }), this.elFront && !this.elFront.matches("body") && (this.elFront.append(this.elPopup), this.shift.top = i.offset(this.el).top - this.el.offsetTop - i.offset(this.elFront).top, this.shift.left = i.offset(this.el).left - this.el.offsetLeft - i.offset(this.elFront).left, this.shift.top -= parseInt(this.el.style["margin-top"] || 0), this.shift.left -= parseInt(this.el.style["margin-left"] || 0), this.elPopup instanceof HTMLElement && (this.elPopup.style.top = parseInt(this.elPopup.style.top || "0") + this.shift.top + "px", this.elPopup.style.left = parseInt(this.elPopup.style.left || "0") + this.shift.left + "px")), this.$ && f.$ && this.$.trigger("aftershow.top-menu-popup", [f.$(this.elPopup)]), this.recalcPosition(), this.elPopup.setAttribute("tabindex", "0"), this.focus(), s.decoratorAfterOpen(this), this.mountEvents();
  }
  async mountJQuery() {
    f.$ && (this.$ = f.$(this.el));
  }
  /**
   * Выполнить фокусировку на нужный элемент после открытия окна
   */
  focus() {
    let t;
    this.elPopup && (t = i.querySelectorVisible(this.elPopup, ".top-popup-autofocus"), t || (t = i.querySelectorVisible(this.elPopup, ":read-write, select:not(:disabled)")), t || (t = i.querySelectorVisible(this.elPopup, ".top-popup_footer .top-button")), t || (t = this.elPopup), t instanceof HTMLElement && t.focus(), setTimeout(() => {
      t instanceof HTMLElement && t.focus();
    }, this.options.transitionDuration));
  }
  mountEvents() {
    this.addEventListenerWithUnmount(document, "mousedown", (t) => this.onMousedown(t)), this.elPopup && this.elPopupInner && (this.addEventListenerWithUnmount(this.elPopup, "focus", (t) => this.onFocus(t)), this.options.openByHover && (this.addEventListenerWithUnmount(this.elPopup, "mouseleave", (t) => this.onMouseleave(t)), this.addEventListenerWithUnmount(this.elPopupInner, "mouseleave", (t) => this.onMouseleave(t)))), this.options.isFullScreen && this.elPopupBody && this.addEventListenerWithUnmount(this.elPopupBody, "touchmove", (t) => this.onTouchmove(t));
  }
  /**
   * Обработка клика вне окна
   */
  onMousedown(t) {
    if (!this.elPopup || !(t.target instanceof Element) || !this.isFirstClick || (this.isFirstClick = !1, setTimeout(() => this.isFirstClick = !0), t instanceof MouseEvent && t.button !== 0))
      return;
    let p = i.querySelectorVisibleLast(document.body, ":scope > .top-popup-wrapper");
    p && p !== this.elPopup || t.target.closest(".top-popup-front") && (p = i.querySelectorVisibleLast(t.target.closest(".top-popup-front"), ":scope > .top-popup-wrapper"), p && p !== this.elPopup) || this.elPopup.contains(t.target) || this.elPopup.closest(".ui-dialog") && !t.target.closest(".ui-dialog") || s.decoratorIsIgnoreOuterClick(t) || s.close(this.elPopup);
  }
  /**
   * Закрыть другие Popup при фокусе на элемент формы в текущем
   */
  onFocus(t) {
    if (t.target instanceof Element && t.target.matches("input") || this.isClosed)
      return;
    s.getAllVisible().forEach((o) => {
      var e, n, r, a;
      (e = this.elPopup) != null && e.contains(o) || ((n = this.popupParent) == null ? void 0 : n.elPopup) === o || ((a = (r = this.popupParent) == null ? void 0 : r.popupParent) == null ? void 0 : a.elPopup) === o || s.close(o);
    });
  }
  /**
   * Закрыть Popup при отведении мыши
   */
  onMouseleave(t) {
    setTimeout(() => {
      this.elPopupInner && this.elPopupInner.matches(":hover") || !this.elPopup || s.close(this.elPopup);
    }, 100);
  }
  /**
   * Контроль положения Popup при fixed позиционировании
   */
  onResize() {
    this.elPopup && this.elPopup.parentElement !== document.body && document.body.append(this.elPopup), this.elPopup instanceof HTMLElement && (this.elPopup.style.top = i.offset(this.el).top + "px", this.elPopup.style.left = i.offset(this.el).left + "px");
  }
  unmount() {
    super.unmount(), this.el instanceof HTMLElement && (this.el.dataset.topPopupOpened = ""), this.elActiveByDefault || this.el.classList.remove("top-active");
    let t = this.el.getAttribute("style");
    t && (t = t.replace(/position:[^;]*;?/g, ""), this.el.setAttribute("style", t));
  }
  // контроль за положением Popup, чтобы оно не вылезало за пределы документа
  recalcPosition(t) {
    var P, b;
    if (!(this.elPopup instanceof HTMLElement)) return;
    let p = t ?? this.options.p, o;
    if (this.el instanceof HTMLElement)
      switch (this.elPopup.style.height = this.el.offsetHeight + "px", this.elPopup.classList.remove("p0", "p1", "p2", "p3", "p4"), this.elPopup.classList.add("p" + p), this.options.posBy) {
        case "left":
          o = this.el.offsetLeft + parseInt(this.el.style["margin-left"] || "0"), o += this.shift.left, this.elPopup.style.left = o + "px";
          break;
        case "right":
          if (!(this.el.offsetParent instanceof HTMLElement)) break;
          o = this.el.offsetLeft + parseInt(this.el.style["margin-left"] || "0"), this.elPopup.style.right = this.el.offsetParent.offsetWidth - this.el.offsetWidth - o + "px";
          break;
        case "fixed":
          this.addEventListenerWithUnmount(window, "resize", () => this.onResize()), this.onResize();
          break;
        default:
          (P = this.options.posBy) == null || P.append(this.elPopup);
      }
    const e = this.elPopup.getBoundingClientRect();
    this.elPopup.style.setProperty("--top-popup-height", this.elPopup.offsetHeight + "px"), this.elPopup.style.setProperty("--top-popup-right-bounding", e.right + "px"), this.elPopup.style.setProperty("--top-popup-bottom-bounding", e.bottom + "px"), this.elPopup.style.setProperty("--top-popup-top", e.top + "px"), this.elPopup.style.setProperty("--top-popup-left", e.left + "px"), this.elPopupInner instanceof HTMLElement && (this.elPopupInner.style.maxWidth = "unset", this.elPopupInner.style.maxHeight = "unset");
    let n = !1, r = !1, a = !1, c = !1, h = e.left > window.innerWidth / 2, d = e.top > window.innerHeight / 2;
    p === 4 && (h = !h), p === 1 && (d = !d);
    const l = (b = this.elPopupInner) == null ? void 0 : b.getBoundingClientRect();
    let u, m;
    if (l) {
      u = window.innerWidth - l.right, m = window.innerHeight - l.bottom;
      const g = 8;
      l.top < g && (n = !0), u < g && (r = !0), m < g && (a = !0), l.left < g && (c = !0);
    }
    n && (p === 0 || p === 1) && d && (p = 3), a && p === 3 && d && (p = 1), r && p === 2 && h && (p = 4), c && p === 4 && h && (p = 2), r && (p === 0 || p === 1 || p === 3) && this.elPopup.classList.add("invert-x"), a && (p === 2 || p === 4) && d && (p === 2 && !h && this.elPopup.classList.add("invert-y"), p === 4 && !h && this.elPopup.classList.add("invert-x"), this.elPopup.matches(".invert-y") || (p = 1)), this.elPopup.classList.remove("p0", "p1", "p2", "p3", "p4"), this.elPopup.classList.add("p" + p), this.elPopupInner instanceof HTMLElement && (this.elPopupInner.style.maxWidth = "", this.elPopupInner.style.maxHeight = ""), s.scrollToActive(this.elPopup);
  }
  onTouchmove(t) {
    var p, o, e;
    if (t.currentTarget instanceof HTMLElement && t.target instanceof HTMLElement) {
      if (t.currentTarget.scrollWidth > t.currentTarget.offsetWidth || (p = t.target.parentElement) != null && p.scrollWidth && ((o = t.target.parentElement) != null && o.offsetWidth) && t.target.parentElement.scrollWidth > ((e = t.target.parentElement) == null ? void 0 : e.offsetWidth))
        return;
      t.currentTarget.matches(".has_scroll") || t.preventDefault();
    }
  }
  close() {
    var t;
    this.isClosed || (this.isClosed = !0, this.$ && f.$ && this.elPopup && this.$.trigger("afterclose.top-menu-popup", [f.$(this.elPopup)]), !s.noClose && (this.unmount(), (t = this.elPopup) == null || t.classList.add("top-popup-wrapper-closed"), setTimeout(() => {
      var e, n, r, a, c;
      if (this.vueClose(), !this.elPopup) return;
      this.options.useOriginal ? (this.elPopup.removeAttribute("style"), this.elPopup.classList.remove("top-popup-wrapper-shown", "top-popup-wrapper-closed"), this.elPopup.classList.add("template"), (e = this.elStartPosition) == null || e.append(this.elPopup), (n = this.elPopup.querySelector("div.top-popup_content.top-column")) == null || n.classList.remove("top-column"), (r = this.elPopup.querySelector(".notch-border")) == null || r.remove(), (a = this.elPopup.querySelector(".notch")) == null || a.remove(), (c = this.elPopupInner) == null || c.replaceWith(...this.elPopupInner.childNodes), i.storageClear(this.elPopup)) : (i.storageClear(this.elPopup), this.elPopup.remove(), delete this.elPopup);
      const p = s.getAllVisible(), o = p.length && p[p.length - 1];
      o ? s.getPopup(o).focus() : document.documentElement.classList.remove("with_popup");
    }, this.options.transitionDuration)));
  }
  async vueOpen() {
    var t;
    await ((t = this.vueGetComponent()) == null ? void 0 : t.onOpen(this));
  }
  vueClose() {
    var t;
    (t = this.vueGetComponent()) == null || t.onClose(this);
  }
  // получить vueConnectors компонента Popup
  vueGetComponent() {
    if (this.el instanceof HTMLElement && this.options.id) return s.vueConnectors.get(this.options.id);
  }
}
y.init();
export {
  v as TopLibPopup
};
//# sourceMappingURL=popup-BaFsC2VD.es.js.map
