import { ref as s, getCurrentInstance as a, inject as i } from "vue";
import { a as n, g as c } from "./dialogs.vue_vue_type_script_setup_true_lang-JyillkBh.es.js";
import { waitWhile as w } from "../utils/system.js";
class l {
  /**
   * Функция, определяющая компонент TopDialogComponent
   */
  resolve;
  /**
   * Реактивная Сссылка на объект worker,
   *
   * Ссылка не будет указывать на объект, если диалоговое окно еще не загружено
   */
  worker = s(null);
  constructor(r) {
    this.resolve = r;
  }
  /**
   * Получить доступ к TopDialogHandle
   */
  async get() {
    if (this.worker.value) return this.worker.value;
    const o = (await this.resolve()).default;
    this.worker.value = k(o);
    const t = this.worker.value;
    return await w(() => !t.isMounted), t;
  }
  /**
   * Открыть диалоговое окно
   */
  async open(...r) {
    await (await this.get()).open(...r);
  }
  /**
   * Открыть диалоговое окно как ссылку, для хеш-навигации
   *
   * Только общедоступные диалоговые окна, расположенные в @/dialogs
   */
  async openAsLink(...r) {
    (await this.get()).openAsLink(...r);
  }
  /**
   * Закрыть диалоговое окно
   *
   * Не меняет состояние компонента диалогового окна
   */
  async close(...r) {
    (await this.get()).close(...r);
  }
  /**
   * Размонтировать виджет диалогового окна
   */
  async destroy(...r) {
    (await this.get()).destroy(...r);
  }
  /**
   * Устанвоить props
   *
   * Полностью сбрасывается состояние props
   */
  async setProps(...r) {
    await (await this.get()).setProps(...r);
  }
}
const d = () => {
  var r;
  const e = a();
  if ((r = e == null ? void 0 : e.type) != null && r.id) {
    const o = c(e.type.id);
    if (o) return o;
  }
  return i("dialogWorker");
}, k = (e) => n(e), h = (e) => new l(e);
export {
  k as a,
  d as b,
  h as u
};
//# sourceMappingURL=utils-BPcGxQ0s.es.js.map
