import { Props as ItemProps, Props, Style } from './item/types';
import { Reactive } from 'vue';
export declare const transitionDuration = 300;
export type Item = Props & {
    onClose?: Function;
};
export declare const itemById: Reactive<Map<string, Item>>;
export type Options = {
    title?: ItemProps['title'];
    metaText?: ItemProps['metaText'];
    buttonProps?: ItemProps['buttonProps'];
    isSafeHTML?: ItemProps['isSafeHTML'];
    selectToClose?: ItemProps['selectToClose'];
    onClose?: Function;
};
/**
 * Показать сообщением в стиле push уведомления
 *
 * title будет получен из первой строки text
 *
 * Если в options указан title, он будет взят оттуда
 */
export declare const show: (text: string, style?: Style, options?: Options) => void;
/**
 * Убрать подозрительный html код
 */
export declare const prepareText: (text: string) => string;
