export type TopDialogOptions = {
    /**
     * Загрузчик для компонентов диалоговых окон по их id
     */
    load?: TopDialogLoad;
    /**
     * Глобальный декоратор на событие инициализации диалогового окна
     */
    decoratorOnCreate?: DecoratorOnCreate;
    /**
     * Пауза перед загрузкой утилиты диалоговых окон в ms
     *
     * Для производительности
     *
     * Утилиты будут в любом случае загружены при работе с диалоговыми окнами, но их не надо грузить каждый раз после открытия страинцы
     */
    autoInitDelay?: number;
};
export type TopDialogLoad = (dialogId: string) => Promise<void>;
export type DecoratorOnCreate = (elDialog: HTMLElement) => Promise<void>;
export type MoveDirection = 'next' | 'prev' | 'none';
