import { MoveDirection, TopDialogOptions } from './types';
import { $el } from '../../types';
export declare abstract class TopDialogWorker {
    static state: {
        load: TopDialogOptions["load"] | undefined;
        decoratorOnCreate: TopDialogOptions["decoratorOnCreate"] | undefined;
        /**
         * Порядковай номер перехода в диалоговых окнах
         *
         * Для расчета анимации Вперед / Назад
         */
        viewPageN: number;
    };
    private static inited;
    /**
     * Инициировать события слежения за парамтерами url
     *
     * Если в параметрах есть запрос на открытие диалогового окна, TopDialog будет автоматически подключен на страницу
     */
    static init(options?: TopDialogOptions): void;
    private static opendDialogsFromChangeUrl;
    static getDialogsUtils(): Promise<{
        updatePageVue: (dialogId: string, pageName?: string, pageNameNext?: string) => Promise<void>;
        recalcPositions: () => void;
        toViewDirty: (toViewPageName: string, moveDirection?: MoveDirection) => Promise<void>;
        toView: (viewNameOr$Dialog: $el | string, pageName?: string, args?: string[], moveDirection?: MoveDirection, callback?: Function) => Promise<void>;
        toViewPage: ($dialog: $el, pageName?: string, args?: string[], moveDirection?: MoveDirection) => Promise<void>;
        toPrevPage: ($dialog: $el) => void;
        setLoading: ($page: $el, isLoading: boolean, duration?: number) => void;
        isLoading: ($page: $el) => boolean;
        inAnimation: ($dialog: $el) => boolean;
        close: (dialogId: string) => void;
    }>;
    static get$dialog($el: $el): JQuery<HTMLElement>;
    static get$page($el: $el): JQuery<HTMLElement>;
    /**
     * Получить элементы страницы в шапке и в контенте
     */
    static get$pairPage($el: $el): JQuery<HTMLElement>;
    /**
     * Закрыть диалоговое окно
     */
    static close(dialogId: string): void;
    /**
     * Размонтировать $.dialog
     */
    static destroy(dialogId: string): void;
    /**
     * Сгенерировать ссылку на страницу в диалоговом окне
     * @param toView - указатель в формате: dialog_{{ dialogId }}={{ pageName }}:{{ args }}
     * @param moveDirection
     */
    static genViewPageHash(toView: string, moveDirection?: MoveDirection): string;
    /**
     * Сравнить версию открытых диалоговых окон
     * @returns вернет true, если состояния открытых окон изменилось
     */
    static compareStates(hash: string, hash2: string): boolean;
    static opendDialogsFromUrl: () => Promise<true | void>;
}
