export interface Props {
    /**
     * Размер
     */
    size?: Size;
    /**
     * Изображение для аватара пользователя
     */
    image: string;
    /**
     * Имя пользователя
     */
    nickname?: string;
    /**
     * Флаг того, что пользователь online
     */
    isOnline?: boolean;
    /**
     * Время в формате Y-m-d H:i:s, когда пользователь был онлайн
     */
    lastActiveTime?: string;
    /**
     * Объект со списком перевода Online и LastSeen
     */
    i18n?: I18n;
}
type I18n = {
    Online: string;
    LastSeen: string;
};
export type Size = 24 | 28 | 40 | 64;
export {};
