/**
 * Определение параметров
 */
export interface Props {
    modelValue: string;
    name?: string;
    placeholder?: string;
    styling?: Style;
    /**
     * Высота поля в строках, не работает в режиме **expandable**
     */
    rows?: number;
    /**
     * Минимальная высота в px для режима **expandable**
     */
    minHeight?: number;
    /**
     * Автоматически изменять высоту при вводе текста
     */
    expandable?: boolean;
    disabled?: boolean;
    readonly?: boolean;
    isError?: boolean;
    /**
     * Добавить к полю элемент с подсказкой, которая будет появляться при наведении
     */
    hint?: string;
}
export declare const styling: {
    readonly regular: "";
    readonly soft: "soft";
    readonly transparent: "transparent";
};
export type Style = typeof styling[keyof typeof styling];
/**
 * Определение событий
 */
export interface Emits {
    (e: 'update:modelValue', value?: string): void;
}
