import { Props as TextareaProps } from '../../forms/textarea/textarea';
export interface Props extends TextareaProps {
    /**
     * Поддерживает modelValue и **все другие** props компонента Textarea
     *
     * См. докуменатцию **Textarea**
     */
    defaultValue?: string;
    title?: string;
    cancelText?: string;
    submitText?: string;
    closeText?: string;
    /**
     * Установить фокус на поле ввода при его появлении
     */
    isFocused?: boolean;
    /**
     * Показывать кнопку **Close** пока ничего не введено или не изменено
     */
    forceShowCloseBtn?: boolean;
    /**
     * Прикрепить к клавиатуре, прикрепляет форму к нижней части экрана
     */
    attachToKeyboard?: boolean;
}
export interface Emits {
    (e: 'submit', value: string): void;
    (e: 'close'): void;
    /**
     * Только если **attachToKeyboard = true**
     */
    (e: 'clickOnTitle'): void;
}
