import { Props as ButtonProps } from '../../forms/button/types';
export interface Props {
    /**
     * Значение активной кнопки, value или href
     */
    modelValue: string | string[] | number | number[];
    /**
     * Дополниетольно поддерижвает все props Button
     */
    items: Item[];
    /**
     * Возможность множественного выбора
     */
    isMultiple?: boolean;
    /**
     * Возможность пустого множества
     */
    canBeEmptyMultiple?: boolean;
    /**
     * Стиль меню
     * default - табы
     * bar - кнопки в баре
     */
    styling?: typeof styling[keyof typeof styling];
    /**
     * Кнопка - выбрать все
     */
    selectAllItem?: Item;
}
export interface Item extends ButtonProps {
    value: string | number;
    content?: string;
}
export declare const styling: {
    readonly default: "default";
    readonly bar: "bar";
};
