import { TopLibPopup } from '../../popup/lib/popup';
import { Item, Props, Slots, Size } from './selector2';
import { ComponentInternalInstance, VNodeProps, AllowedComponentProps, ComponentCustomProps, Slot, ComponentPublicInstance, ComponentOptionsBase, ComponentOptionsMixin, GlobalComponents, GlobalDirectives, ComponentProvideOptions, DebuggerEvent, nextTick, WatchOptions, WatchStopHandle, ShallowUnwrapRef, ComponentCustomProperties, DefineComponent, PublicProps } from 'vue';
import { PopupEvent, Props } from '../../popup/popup/popup';
import { OnCleanup } from '@vue/reactivity';
type __VLS_Props = Props;
type __VLS_PublicProps = {
    modelValue?: Props['modelValue'];
} & __VLS_Props;
declare function __VLS_template(): {
    attrs: Partial<{}>;
    slots: Readonly<Slots> & Slots;
    refs: {
        popupRef: ({
            $: ComponentInternalInstance;
            $data: {};
            $props: {
                readonly id?: string | undefined;
                readonly class?: string | undefined;
                readonly transitionDuration?: number | undefined;
                readonly footerSupportLink?: string | undefined;
                readonly pos?: "0" | "1" | "2" | "3" | "4" | undefined;
                readonly notch?: boolean | undefined;
                readonly openByHover?: boolean | undefined;
                readonly posBy?: "fixed" | "left" | "right" | undefined;
                readonly onClose?: ((popupEvent: PopupEvent) => any) | undefined;
                readonly onOpen?: ((popupEvent: PopupEvent) => any) | undefined;
                readonly onScrollContentList?: ((e: Event) => any) | undefined;
            } & VNodeProps & AllowedComponentProps & ComponentCustomProps;
            $attrs: {
                [x: string]: unknown;
            };
            $refs: {
                [x: string]: unknown;
            };
            $slots: Readonly<{
                [name: string]: Slot<any> | undefined;
            }>;
            $root: ComponentPublicInstance | null;
            $parent: ComponentPublicInstance | null;
            $host: Element | null;
            $emit: ((event: "close", popupEvent: PopupEvent) => void) & ((event: "open", popupEvent: PopupEvent) => void) & ((event: "scrollContentList", e: Event) => void);
            $el: any;
            $options: ComponentOptionsBase<Readonly< Props> & Readonly<{
                onClose?: ((popupEvent: PopupEvent) => any) | undefined;
                onOpen?: ((popupEvent: PopupEvent) => any) | undefined;
                onScrollContentList?: ((e: Event) => any) | undefined;
            }>, {
                popup: TopLibPopup | undefined;
            }, {}, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
                close: (popupEvent: PopupEvent) => any;
                open: (popupEvent: PopupEvent) => any;
                scrollContentList: (e: Event) => any;
            }, string, {
                id: string;
                posBy: "fixed" | "left" | "right";
                pos: "0" | "1" | "2" | "3" | "4";
                notch: boolean;
            }, {}, string, {}, GlobalComponents, GlobalDirectives, string, ComponentProvideOptions> & {
                beforeCreate?: (() => void) | (() => void)[];
                created?: (() => void) | (() => void)[];
                beforeMount?: (() => void) | (() => void)[];
                mounted?: (() => void) | (() => void)[];
                beforeUpdate?: (() => void) | (() => void)[];
                updated?: (() => void) | (() => void)[];
                activated?: (() => void) | (() => void)[];
                deactivated?: (() => void) | (() => void)[];
                beforeDestroy?: (() => void) | (() => void)[];
                beforeUnmount?: (() => void) | (() => void)[];
                destroyed?: (() => void) | (() => void)[];
                unmounted?: (() => void) | (() => void)[];
                renderTracked?: ((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[];
                renderTriggered?: ((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[];
                errorCaptured?: ((err: unknown, instance: ComponentPublicInstance | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance | null, info: string) => boolean | void)[];
            };
            $forceUpdate: () => void;
            $nextTick: nextTick;
            $watch<T extends string | ((...args: any) => any)>(source: T, cb: T extends (...args: any) => infer R ? (...args: [R, R, OnCleanup]) => any : (...args: [any, any, OnCleanup]) => any, options?: WatchOptions): WatchStopHandle;
        } & Readonly<{
            id: string;
            posBy: "fixed" | "left" | "right";
            pos: "0" | "1" | "2" | "3" | "4";
            notch: boolean;
        }> & Omit<Readonly< Props> & Readonly<{
            onClose?: ((popupEvent: PopupEvent) => any) | undefined;
            onOpen?: ((popupEvent: PopupEvent) => any) | undefined;
            onScrollContentList?: ((e: Event) => any) | undefined;
        }>, ("id" | "posBy" | "pos" | "notch") | "popup"> & ShallowUnwrapRef<{
            popup: TopLibPopup | undefined;
        }> & {} & ComponentCustomProperties & {} & {
            $slots: {
                opener?(_: {}): any;
                header?(_: {}): any;
                widget?(_: {}): any;
                content?(_: {}): any;
                contentList?(_: {}): any;
                footer?(_: {}): any;
            };
        }) | null;
        elRef: HTMLDivElement;
    };
    rootEl: any;
};
type __VLS_TemplateResult = ReturnType<typeof __VLS_template>;
declare const __VLS_component: DefineComponent<__VLS_PublicProps, {}, {}, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    "update:modelValue": (value: Item | Item[]) => any;
}, string, PublicProps, Readonly<__VLS_PublicProps> & Readonly<{
    "onUpdate:modelValue"?: ((value: Item | Item[]) => any) | undefined;
}>, {
    size: Size;
    items: Item[];
    minLength: number;
    showSelectedInInput: boolean;
    showSearch: boolean;
}, {}, {}, {}, string, ComponentProvideOptions, false, {
    popupRef: ({
        $: ComponentInternalInstance;
        $data: {};
        $props: {
            readonly id?: string | undefined;
            readonly class?: string | undefined;
            readonly transitionDuration?: number | undefined;
            readonly footerSupportLink?: string | undefined;
            readonly pos?: "0" | "1" | "2" | "3" | "4" | undefined;
            readonly notch?: boolean | undefined;
            readonly openByHover?: boolean | undefined;
            readonly posBy?: "fixed" | "left" | "right" | undefined;
            readonly onClose?: ((popupEvent: PopupEvent) => any) | undefined;
            readonly onOpen?: ((popupEvent: PopupEvent) => any) | undefined;
            readonly onScrollContentList?: ((e: Event) => any) | undefined;
        } & VNodeProps & AllowedComponentProps & ComponentCustomProps;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: Slot<any> | undefined;
        }>;
        $root: ComponentPublicInstance | null;
        $parent: ComponentPublicInstance | null;
        $host: Element | null;
        $emit: ((event: "close", popupEvent: PopupEvent) => void) & ((event: "open", popupEvent: PopupEvent) => void) & ((event: "scrollContentList", e: Event) => void);
        $el: any;
        $options: ComponentOptionsBase<Readonly< Props> & Readonly<{
            onClose?: ((popupEvent: PopupEvent) => any) | undefined;
            onOpen?: ((popupEvent: PopupEvent) => any) | undefined;
            onScrollContentList?: ((e: Event) => any) | undefined;
        }>, {
            popup: TopLibPopup | undefined;
        }, {}, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
            close: (popupEvent: PopupEvent) => any;
            open: (popupEvent: PopupEvent) => any;
            scrollContentList: (e: Event) => any;
        }, string, {
            id: string;
            posBy: "fixed" | "left" | "right";
            pos: "0" | "1" | "2" | "3" | "4";
            notch: boolean;
        }, {}, string, {}, GlobalComponents, GlobalDirectives, string, ComponentProvideOptions> & {
            beforeCreate?: (() => void) | (() => void)[];
            created?: (() => void) | (() => void)[];
            beforeMount?: (() => void) | (() => void)[];
            mounted?: (() => void) | (() => void)[];
            beforeUpdate?: (() => void) | (() => void)[];
            updated?: (() => void) | (() => void)[];
            activated?: (() => void) | (() => void)[];
            deactivated?: (() => void) | (() => void)[];
            beforeDestroy?: (() => void) | (() => void)[];
            beforeUnmount?: (() => void) | (() => void)[];
            destroyed?: (() => void) | (() => void)[];
            unmounted?: (() => void) | (() => void)[];
            renderTracked?: ((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[];
            renderTriggered?: ((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[];
            errorCaptured?: ((err: unknown, instance: ComponentPublicInstance | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance | null, info: string) => boolean | void)[];
        };
        $forceUpdate: () => void;
        $nextTick: nextTick;
        $watch<T extends string | ((...args: any) => any)>(source: T, cb: T extends (...args: any) => infer R ? (...args: [R, R, OnCleanup]) => any : (...args: [any, any, OnCleanup]) => any, options?: WatchOptions): WatchStopHandle;
    } & Readonly<{
        id: string;
        posBy: "fixed" | "left" | "right";
        pos: "0" | "1" | "2" | "3" | "4";
        notch: boolean;
    }> & Omit<Readonly< Props> & Readonly<{
        onClose?: ((popupEvent: PopupEvent) => any) | undefined;
        onOpen?: ((popupEvent: PopupEvent) => any) | undefined;
        onScrollContentList?: ((e: Event) => any) | undefined;
    }>, ("id" | "posBy" | "pos" | "notch") | "popup"> & ShallowUnwrapRef<{
        popup: TopLibPopup | undefined;
    }> & {} & ComponentCustomProperties & {} & {
        $slots: {
            opener?(_: {}): any;
            header?(_: {}): any;
            widget?(_: {}): any;
            content?(_: {}): any;
            contentList?(_: {}): any;
            footer?(_: {}): any;
        };
    }) | null;
    elRef: HTMLDivElement;
}, any>;
declare const _default: __VLS_WithTemplateSlots<typeof __VLS_component, __VLS_TemplateResult["slots"]>;
export default _default;
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
