/**
 * Глобальные события, для реализации Popup
 * Автоматически инициируется при первой загрузке, не является выгружаемым модулем
 *
 * Если в меню встречает класс .preloader, то событие нажатия на кнопку через enter будет остановлено
 */
declare class GlobalEvents {
    private static isInited;
    /**
     * Добавить глобальные обработчики
     *
     * Добавляются на страницу один раз и навсегда
     */
    static init(): void;
    /**
     * Глобальный обработчик захватов кликов
     *
     * Обрабатывает захватов клики внутри Popup
     */
    private static onclickCapture;
    /**
     * Глобальный обработчик кликов
     *
     * Обрабатывает клики внутри Popup
     */
    private static onclick;
    /**
     * Глобальный обработчик нажатия кнопки на клавиатуре
     */
    private static onkeydown;
}
export default GlobalEvents;
