import { ComputedRef, Ref } from 'vue';
import { Props, SearcherByKey } from '../selectorRegion';
/**
 * Создание и управление реактивными переменными для сравнения
 *
 * @param props - входные props компонента
 * @param searcherByKey - Map ПС (реактивная)
 * @param allRegionsIndexes - Все доступные индексы регионов (реактивная)
 */
export declare const useCompare: (props: Props, searcherByKey: ComputedRef<SearcherByKey>, allRegionsIndexes: ComputedRef<Set<number>>) => {
    regionsIndexes: Ref<number[], number[]>;
};
