import { ComputedRef, Ref } from 'vue';
import { Option } from '../../../forms/select/select';
import { Props, SearcherIndexed } from '../selectorRegion';
/**
 * Создание и управление реактивными переменными для выбора региона
 *
 * @param props - входные props компонента
 * @param activeSearcherIndexed - объект активной поисковой системы (реактивная)
 */
export declare const useSelectRegion: (props: Props, activeSearcherIndexed: ComputedRef<SearcherIndexed>) => {
    regionIndex: Ref<number, number>;
    optionByRegionIndex: ComputedRef<Map<number, Option>>;
};
