import { Props, Region, SearcherIndexed, SearcherByKey } from '../selectorRegion';
import { Ref, ComputedRef } from 'vue';
import { Options, Option } from '../../../forms/select/select';
/**
 * Создание и управления рективными переменными компонента
 *
 * @param props - входные props компонента
 */
export declare const useSelectorRegion: (props: Props) => {
    selectSearcher: {
        searcherKey: Ref<number, number>;
        optionBySearcherKey: ComputedRef<Options>;
    };
    selectRegion: {
        regionIndex: Ref<number, number>;
        optionByRegionIndex: ComputedRef<Map<number, Option>>;
    };
    compare: {
        regionsIndexes: Ref<number[], number[]>;
    };
    searcherByKey: ComputedRef<SearcherByKey>;
    allRegionsIndexes: ComputedRef<Set<number>>;
    getSearcher: () => SearcherIndexed | undefined;
    getRegion: () => Region | undefined;
};
