import { Region, Searcher, SearcherByKey } from '../selectorRegion';
import { AsyncTopDialogHandle } from '../../../dialog/dialog/composables/asyncDialogHandle';
import { DefineComponent, ComponentOptionsMixin, PublicProps, ComponentProvideOptions } from 'vue';
import { Props } from '../dialog_selectorRegions/types';
/**
 * Генерация Map ПС с Map регионов из массива searchers
 * - ключ для ПС - searcherKey
 * - ключ для региона - regionIndex
 *
 * Если поисковиков в списке нет, в список будет добавлен searcherUndefined
 *
 * Если регионов в списке нет, в список будет добавлен regionUndefined
 *
 * @param forFrequency - получить массив для просмотра частоты (или ставок)
 * @param autoRegion - добавить элемент с ключем -2, который в API заменяется на нужный ключ в зависимости от контекста
 * @param searchers - поисковики с регионами проекта, см.: get/projects_2/projects, show_searchers_and_regions = 1
 */
export declare const genSearcherByKey: (forFrequency?: boolean, autoRegion?: boolean, searchers?: Searcher[]) => SearcherByKey;
/**
 * Поиск региона по заданному критерию из списка поисковиков проекта
 *
 * @param forFrequency - поиск региона для просмотра частоты или ставок
 * @param searchRegion - объект с параметрами региона, который следует найти
 * @param searchers
 */
export declare const findRegion: (forFrequency: boolean, searchRegion: Partial<Region>, searchers?: Searcher[]) => Region | undefined;
/**
 * Открыть диалоговое окно с выбором нескольких регионов
 *
 * @see import('../dialog_selectorRegions/types').Props
 */
export declare const dialogSelectorRegions: AsyncTopDialogHandle<DefineComponent<Partial< Props>, {}, {}, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, PublicProps, Readonly<Partial< Props>> & Readonly<{}>, {}, {}, {}, {}, string, ComponentProvideOptions, false, {
    elRegions: HTMLDivElement;
}, HTMLDivElement>>;
