import { Ref } from 'vue';
import { OpenerProps as PopupOpenerProps } from '../../../popup/popup/popup';
import { Props as TagSelectorOpenerProps } from '../popupOpener/types';
/**
 * Сгенерировтаь элемент для открытия popup с выбором тегов
 *
 * Альтернатива TopTagSelecorPopupOpener для работы вне vue
 *
 * Требует монтирования компонента TopTagSelecor
 */
export declare const genElPopupOpener: (props: TagSelectorOpenerProps & {
    modelValue: TagSelectorOpenerProps["modelValue"] | Ref<TagSelectorOpenerProps["modelValue"]>;
}, propsPopup?: Partial<PopupOpenerProps>, htmlSetterSeveral?: string) => HTMLElement;
/**
 * Вызвать перерисовку элемента, который был создан через genElPopupOpener()
 *
 * Работет только для элементов не с реактивным modelValue
 */
export declare const renderElPopupOpener: (el: HTMLElement, modelValue: TagSelectorOpenerProps["modelValue"]) => void;
