import { InjectionKey, ModelRef, Slot, Component, ComputedOptions, MethodOptions, Directive, WatchCallback, WatchOptions, ComponentProvideOptions, DebuggerEvent, ComponentPublicInstance, ComponentPropsOptions } from 'vue';
import { Props, Store } from './tabsView';
import { LooseRequired } from '@vue/shared';
import { Store } from '../../../core/utils/store/store';
export declare const injectionKey: InjectionKey<Store>;
/**
 * Инициировать Store компонента
 */
export declare const defineTabsStore: (props: Props, model: ModelRef<string | undefined>) => {
    showMenuInPopup: Props["showMenuInPopup"];
    isShort: boolean;
    activeItemName: Props["modelValue"];
    component: {
        [x: string]: any;
        setup: (this: void, props: LooseRequired<any>, ctx: {
            attrs: {
                [x: string]: unknown;
            };
            slots: Readonly<{
                [name: string]: Slot<any> | undefined;
            }>;
            emit: ((event: unknown, ...args: any[]) => void) | ((event: string, ...args: any[]) => void);
            expose: <Exposed extends Record<string, any> = Record<string, any>>(exposed?: Exposed) => void;
        }) => any;
        name: string;
        template: string | object;
        render: Function;
        components: Record<string, Component<any, any, any, ComputedOptions, MethodOptions, {}, any>>;
        directives: Record<string, Directive<any, any, string, string>>;
        inheritAttrs: boolean;
        emits: any;
        slots: {};
        expose: string[];
        serverPrefetch: () => void | Promise<any>;
        compilerOptions: {
            isCustomElement?: ((tag: string) => boolean) | undefined;
            whitespace?: "preserve" | "condense" | undefined;
            comments?: boolean | undefined;
            delimiters?: [string, string] | undefined;
        };
        call: (this: unknown, ...args: unknown[]) => never;
        __isFragment: never;
        __isTeleport: never;
        __isSuspense: never;
        __defaults: {};
        compatConfig: {
            GLOBAL_MOUNT?: boolean | "suppress-warning" | undefined;
            GLOBAL_MOUNT_CONTAINER?: boolean | "suppress-warning" | undefined;
            GLOBAL_EXTEND?: boolean | "suppress-warning" | undefined;
            GLOBAL_PROTOTYPE?: boolean | "suppress-warning" | undefined;
            GLOBAL_SET?: boolean | "suppress-warning" | undefined;
            GLOBAL_DELETE?: boolean | "suppress-warning" | undefined;
            GLOBAL_OBSERVABLE?: boolean | "suppress-warning" | undefined;
            GLOBAL_PRIVATE_UTIL?: boolean | "suppress-warning" | undefined;
            CONFIG_SILENT?: boolean | "suppress-warning" | undefined;
            CONFIG_DEVTOOLS?: boolean | "suppress-warning" | undefined;
            CONFIG_KEY_CODES?: boolean | "suppress-warning" | undefined;
            CONFIG_PRODUCTION_TIP?: boolean | "suppress-warning" | undefined;
            CONFIG_IGNORED_ELEMENTS?: boolean | "suppress-warning" | undefined;
            CONFIG_WHITESPACE?: boolean | "suppress-warning" | undefined;
            CONFIG_OPTION_MERGE_STRATS?: boolean | "suppress-warning" | undefined;
            INSTANCE_SET?: boolean | "suppress-warning" | undefined;
            INSTANCE_DELETE?: boolean | "suppress-warning" | undefined;
            INSTANCE_DESTROY?: boolean | "suppress-warning" | undefined;
            INSTANCE_EVENT_EMITTER?: boolean | "suppress-warning" | undefined;
            INSTANCE_EVENT_HOOKS?: boolean | "suppress-warning" | undefined;
            INSTANCE_CHILDREN?: boolean | "suppress-warning" | undefined;
            INSTANCE_LISTENERS?: boolean | "suppress-warning" | undefined;
            INSTANCE_SCOPED_SLOTS?: boolean | "suppress-warning" | undefined;
            INSTANCE_ATTRS_CLASS_STYLE?: boolean | "suppress-warning" | undefined;
            OPTIONS_DATA_FN?: boolean | "suppress-warning" | undefined;
            OPTIONS_DATA_MERGE?: boolean | "suppress-warning" | undefined;
            OPTIONS_BEFORE_DESTROY?: boolean | "suppress-warning" | undefined;
            OPTIONS_DESTROYED?: boolean | "suppress-warning" | undefined;
            WATCH_ARRAY?: boolean | "suppress-warning" | undefined;
            PROPS_DEFAULT_THIS?: boolean | "suppress-warning" | undefined;
            V_ON_KEYCODE_MODIFIER?: boolean | "suppress-warning" | undefined;
            CUSTOM_DIR?: boolean | "suppress-warning" | undefined;
            ATTR_FALSE_VALUE?: boolean | "suppress-warning" | undefined;
            ATTR_ENUMERATED_COERCION?: boolean | "suppress-warning" | undefined;
            TRANSITION_CLASSES?: boolean | "suppress-warning" | undefined;
            TRANSITION_GROUP_ROOT?: boolean | "suppress-warning" | undefined;
            COMPONENT_ASYNC?: boolean | "suppress-warning" | undefined;
            COMPONENT_FUNCTIONAL?: boolean | "suppress-warning" | undefined;
            COMPONENT_V_MODEL?: boolean | "suppress-warning" | undefined;
            RENDER_FUNCTION?: boolean | "suppress-warning" | undefined;
            FILTERS?: boolean | "suppress-warning" | undefined;
            PRIVATE_APIS?: boolean | "suppress-warning" | undefined;
            MODE?: 2 | 3 | ((comp: Component | null) => 2 | 3) | undefined;
        };
        data: (this: any, vm: any) => any;
        computed: ComputedOptions;
        methods: MethodOptions;
        watch: {
            [x: string]: (string | WatchCallback | ({
                handler: WatchCallback | string;
            } & WatchOptions<boolean>)) | (string | WatchCallback | ({
                handler: WatchCallback | string;
            } & WatchOptions<boolean>))[];
        };
        provide: ComponentProvideOptions;
        inject: {} | string[];
        filters: Record<string, Function>;
        mixins: any[];
        extends: any;
        beforeCreate: () => void;
        created: () => void;
        beforeMount: () => void;
        mounted: () => void;
        beforeUpdate: () => void;
        updated: () => void;
        activated: () => void;
        deactivated: () => void;
        beforeDestroy: () => void;
        beforeUnmount: () => void;
        destroyed: () => void;
        unmounted: () => void;
        renderTracked: (e: DebuggerEvent) => void;
        renderTriggered: (e: DebuggerEvent) => void;
        errorCaptured: (err: unknown, instance: ComponentPublicInstance | null, info: string) => boolean | void;
        delimiters: [string, string];
        __differentiator: string | number | symbol;
        __isBuiltIn: boolean;
        __file: string;
        __name: string;
    } | {
        props: ComponentPropsOptions<any>;
        emits: never[] | {};
        slots: Readonly<{
            [name: string]: Slot<any> | undefined;
        }>;
        inheritAttrs: boolean;
        displayName: string;
        compatConfig: {
            GLOBAL_MOUNT?: boolean | "suppress-warning" | undefined;
            GLOBAL_MOUNT_CONTAINER?: boolean | "suppress-warning" | undefined;
            GLOBAL_EXTEND?: boolean | "suppress-warning" | undefined;
            GLOBAL_PROTOTYPE?: boolean | "suppress-warning" | undefined;
            GLOBAL_SET?: boolean | "suppress-warning" | undefined;
            GLOBAL_DELETE?: boolean | "suppress-warning" | undefined;
            GLOBAL_OBSERVABLE?: boolean | "suppress-warning" | undefined;
            GLOBAL_PRIVATE_UTIL?: boolean | "suppress-warning" | undefined;
            CONFIG_SILENT?: boolean | "suppress-warning" | undefined;
            CONFIG_DEVTOOLS?: boolean | "suppress-warning" | undefined;
            CONFIG_KEY_CODES?: boolean | "suppress-warning" | undefined;
            CONFIG_PRODUCTION_TIP?: boolean | "suppress-warning" | undefined;
            CONFIG_IGNORED_ELEMENTS?: boolean | "suppress-warning" | undefined;
            CONFIG_WHITESPACE?: boolean | "suppress-warning" | undefined;
            CONFIG_OPTION_MERGE_STRATS?: boolean | "suppress-warning" | undefined;
            INSTANCE_SET?: boolean | "suppress-warning" | undefined;
            INSTANCE_DELETE?: boolean | "suppress-warning" | undefined;
            INSTANCE_DESTROY?: boolean | "suppress-warning" | undefined;
            INSTANCE_EVENT_EMITTER?: boolean | "suppress-warning" | undefined;
            INSTANCE_EVENT_HOOKS?: boolean | "suppress-warning" | undefined;
            INSTANCE_CHILDREN?: boolean | "suppress-warning" | undefined;
            INSTANCE_LISTENERS?: boolean | "suppress-warning" | undefined;
            INSTANCE_SCOPED_SLOTS?: boolean | "suppress-warning" | undefined;
            INSTANCE_ATTRS_CLASS_STYLE?: boolean | "suppress-warning" | undefined;
            OPTIONS_DATA_FN?: boolean | "suppress-warning" | undefined;
            OPTIONS_DATA_MERGE?: boolean | "suppress-warning" | undefined;
            OPTIONS_BEFORE_DESTROY?: boolean | "suppress-warning" | undefined;
            OPTIONS_DESTROYED?: boolean | "suppress-warning" | undefined;
            WATCH_ARRAY?: boolean | "suppress-warning" | undefined;
            PROPS_DEFAULT_THIS?: boolean | "suppress-warning" | undefined;
            V_ON_KEYCODE_MODIFIER?: boolean | "suppress-warning" | undefined;
            CUSTOM_DIR?: boolean | "suppress-warning" | undefined;
            ATTR_FALSE_VALUE?: boolean | "suppress-warning" | undefined;
            ATTR_ENUMERATED_COERCION?: boolean | "suppress-warning" | undefined;
            TRANSITION_CLASSES?: boolean | "suppress-warning" | undefined;
            TRANSITION_GROUP_ROOT?: boolean | "suppress-warning" | undefined;
            COMPONENT_ASYNC?: boolean | "suppress-warning" | undefined;
            COMPONENT_FUNCTIONAL?: boolean | "suppress-warning" | undefined;
            COMPONENT_V_MODEL?: boolean | "suppress-warning" | undefined;
            RENDER_FUNCTION?: boolean | "suppress-warning" | undefined;
            FILTERS?: boolean | "suppress-warning" | undefined;
            PRIVATE_APIS?: boolean | "suppress-warning" | undefined;
            MODE?: 2 | 3 | ((comp: Component | null) => 2 | 3) | undefined;
        };
        __isBuiltIn: boolean;
        __file: string;
        __name: string;
    } | {
        __isFragment: never;
        __isTeleport: never;
        __isSuspense: never;
    } | undefined;
    scrollable?: boolean | undefined;
} & Store;
/**
 * Получить Store компонента
 */
export declare const useTabsStore: () => Store & Store;
