/**
 * State UI для взаимодейсвтиями с приложениями Vue
 */
declare const state: {
    /**
     * CSS-классы модификаторы для документа страницы
     */
    documentClassModificators: Map<string | number, string>;
    dateFormat: string;
    currency: "USD" | "RUB" | "EUR";
    gmt: string;
    /**
     * Device by size
     *
     * @see Core widthForMobile
     */
    isMobile: boolean;
    /**
     * Device by user agent
     */
    isMobileUA: boolean;
    /**
     * true, если плотность пикселей экрана больше 1
     */
    isRetina: boolean;
    /**
     * true, елси это приложение
     */
    isApp: boolean;
    /**
     * true при горизонтальном расположении устройства
     */
    isLandscape: boolean;
    /**
     * true при вертикальном расположении устройства
     */
    isPortrait: boolean;
    /**
     * Максимальная сторона страницы
     */
    size: number;
    /**
     * true, если страница скрыта
     *
     * Не меняйте это значение вручную
     */
    isHidden: boolean;
};
export default state;
