import { PiniaPluginContext } from 'pinia';
/**
 * Плагин tpa (Third-party access) для pinia
 *
 * Добавляет возможность сохранять и загружать данные в/из:
 * 	- URL hash в адресе страницы
 * 	- localStorage
 * 	- гостевая ссылка
 *
 * Для подключения плагина нужно указань одну или несколько опций при определении defineStore():
 * - tpaNamesUrlHash
 * - tpaNamesStorage
 * - tpaNamesStorageLocal
 * - tpaNamesGuestLink
 */
declare const _default: (contextPinia: PiniaPluginContext) => void;
export default _default;
