/**
 * Функции для проверки данных
 * @packageDocumentation
 */
/**
 * Получить строку с регулярным выражение для домена
 */
export declare const getDomainRegexp: () => string;
/**
 * Проверка валидности email
 * @param email
 * @param rus_allow - если true, русскоязычные адреса тоже будут валидны
 */
export declare const isEmail: (email: string, rus_allow?: boolean) => boolean;
/**
 * Проверка валидности URL-адреса
 */
export declare const validUrl: (url: string, allowIP?: boolean) => boolean;
/**
 * Проверка валидности домена
 */
export declare const isDomain: (domain: string) => boolean;
/**
 * Проверка валидности ip
 */
export declare const isIp: (ip: string) => boolean;
