/**
 * Получение информации об устройстве
 * @packageDocumentation
 */
/**
 * Определить, увеличинная ли плотность пикселей у экрана (DPR > 1)
 */
export declare function isRetina(): boolean;
/**
 * Определить, является ли устройство мобильным
 */
export declare function isMobile(): boolean;
/**
 * Определить, открыт ли сайт в приложении
 */
export declare function isApp(): boolean;
/**
 * Определить, является ли OS пользователя macOS
 */
export declare function isMacOS(): boolean;
/**
 * Определить, является ли текущий браузер пользователя Safari
 */
export declare function isSafari(): boolean;
/**
 * Вернуть текст для обозначения клавиши Ctrl / Command в зависимости от OS
 */
export declare function getCommandKeyLabel(): 'Ctrl' | '⌘';
/**
 * Вернуть скролл с учетом устройства
 */
export declare const getScrollTop: () => number | undefined;
/**
 * Вернуть контейнеры со скроллом (требует jquery)
 */
export declare const get$scroll: () => JQuery<Document>;
/**
 * Вернуть контейнеры со скроллом (без jquery)
 */
export declare const getElsScroll: () => Document[];
/**
 * Получить операционную систему пользователя
 *
 * Не определяет Windows 11, см. getOSAsync()
 */
export declare const getOS: () => string;
/**
 * Получить операционную систему пользователя, в том числе Windows 11
 */
export declare const getOSAsync: () => Promise<string>;
