/**
 * Управление навигацией страницы, работа с hash параметрами страницы
 * @packageDocumentation
 */
/**
 * Получить значение хэш параметра страницы
 */
export declare const getHash: (name: string, locationHash?: string) => string;
/**
 * Установить значение в хэш параметр страницы
 */
export declare const setHash: (name: string, value: string | number | null, replaceState?: boolean) => void;
/**
 * Удалить значение из хэш параметра страницы
 */
export declare const delHash: (name: string, value: string, replaceState?: boolean) => void;
/**
 * Сгенерировать новое значение для хэш параметра страницы с указанным параметром
 */
export declare const genHash: (name: string, value: string | number | null, locationHash?: string) => string;
/**
 * Установить значения в хэш параметр страницы
 */
export declare const setHashs: (data: Map<string, string> | object | any, replaceState: boolean) => void;
/**
 * Установть позицию в истории вкладки браузера
 *
 * @see history.replaceState
 * @see history.pushState
 *
 * @todo Объединить с historyPushState() из @/component/vue/app/spa
 */
export declare const historySetState: (replace: boolean | undefined, hash: string) => void;
