/**
 * Системные утилиты
 * @packageDocumentation
 */
/**
 * Ждать, пока условие истинно
 *
 * @param condition - функция, вычисляющая значение
 * @param period - период в мс между выполнениями condition()
 * @param timeout - максмальное время ожидания в мс
 */
export declare const waitWhile: (condition: Function, period?: number, timeout?: number) => Promise<void> | undefined;
/**
 * Приостановить выполнение кода
 *
 * @param delay - длительность паузы в мс
 */
export declare const sleep: (delay: number) => Promise<void>;
/**
 * Приостановить выполнение кода пока условие истинно
 * @param condition - функция, вычисляющая значение
 * @param delay - время задержки в мс
 * @param period - период в мс между выполнениями condition()
 */
export declare const sleepWhile: (condition: Function, delay?: number, period?: number) => Promise<void> | undefined;
