/**
 * Работа с урлами
 * @packageDocumentation
 */
/**
 * Раскодировать все не ASCII символы в домене URL
 * @param url - домен в ASCII формате
 * @return домен в Unicode формате
 */
export declare const fromPuny: (url?: string) => string;
/**
 * Закодировать все не ASCII символы в домене URL
 * @param url - домен в Unicode формате
 * @return домен в ASCII формате
 */
export declare const toPuny: (url: string) => string;
/**
 * Получить имя хоста из URL
 */
export declare const getHost: (url: string) => string;
/**
 * Привести url к стандартному виду (не в пуникоде и хост в нижнем регистре)
 */
export declare const normalize: (url: string) => string;
/**
 * Перевести в url имя хоста в нижний регистр
 */
export declare const hostToLowerCase: (url: string) => string;
/**
 * Получить закодированную строку
 */
export declare const encode: (string: string) => string;
/**
 * Раскодировать строку, полученную функцией encode
 */
export declare const decode: (string: string) => string;
