import { C as Core } from "../.chunks/forms-zDpk9gMK.es.js";
import DOM from "../utils/dom.js";
class Worker {
  /**
   * Глобальное выключение закрытия меню, используется при различных оверлеях
   */
  static noClose = !1;
  /**
   * Для взаимодействия с vue
   */
  static vueConnectors = /* @__PURE__ */ new Map();
  static options = {};
  /**
   * Вернуть объект компонента popup, привязанный к элементу
   */
  static getPopup(t) {
    return DOM.storage(t, "TopPopup");
  }
  /**
   * Вернуть все элементы с Popup
   */
  static getAll() {
    return DOM.querySelectorAllArray(document, ".top-popup-wrapper");
  }
  /**
   * Вернуть все элементы с открытыми Popup
   */
  static getAllVisible() {
    return DOM.querySelectorAllVisible(document, ".top-popup-wrapper");
  }
  /**
   * Открть Popup от указанного elOpener
   * @param {HTMLElement} elOpener - элемент, который должен вызвать открытие Popup
   */
  static async openByOpener(t) {
    if (!(t instanceof HTMLElement)) return;
    const o = {};
    return o.popup = t.dataset.topPopup, o.id = t.dataset.topPopupId, t.dataset.topPopupP && (o.p = parseInt(t.dataset.topPopupP)), t.dataset.topPopupPos && (o.p = parseInt(t.dataset.topPopupPos)), t.dataset.topPopupNotch && (o.notch = t.dataset.topPopupNotch === "true" || t.dataset.topPopupNotch === "1"), t.dataset.topPopupClass && (o.class = t.dataset.topPopupClass), t.dataset.topPopupPosBy && (o.posBy = t.dataset.topPopupPosBy), t.dataset.topPopupFront && (o.frontSelector = t.dataset.topPopupFront), t.dataset.topPopupInvertX && (o.invertX = t.dataset.topPopupInvertX === "true" || t.dataset.topPopupInvertX === "1"), t.dataset.topPopupOpenByHover && (o.openByHover = t.dataset.topPopupOpenByHover === "true" || t.dataset.topPopupOpenByHover === "1"), t.dataset.topPopupUseOriginal && (o.useOriginal = t.dataset.topPopupUseOriginal === "true" || t.dataset.topPopupUseOriginal === "1"), await Worker.open(t, o);
  }
  /**
   * Создать и открыть Popup
   * @param elOpener - элемент, вызвавший открытие Popup
   * @param options - опции Popup
   */
  static async open(elOpener, options) {
    elOpener instanceof HTMLElement && (elOpener.dataset.topPopupOpened = "opened");
    const { TopLibPopup } = await import("../.chunks/popup-BaFsC2VD.es.js");
    if (Core.$) {
      const $elOpener = Core.$(elOpener);
      if ($elOpener.data("aftershow")) {
        let afterShow = $elOpener.data("aftershow");
        typeof afterShow == "string" && (afterShow = eval(afterShow.replace(/\W/g, ""))), $elOpener.one("aftershow.top-menu-popup", afterShow);
      }
      if ($elOpener.data("afterclose")) {
        let afterclose = $elOpener.data("afterclose");
        typeof afterclose == "string" && (afterclose = eval(afterclose.replace(/\W/g, ""))), $elOpener.one("afterclose.top-menu-popup", afterclose);
      }
    }
    return options.isFullScreen = Core.state.isMobile, new TopLibPopup(elOpener, options);
  }
  static close(t) {
    const o = Worker.getPopup(t);
    o && o.close();
  }
  static recalcPosition(t) {
    const o = Worker.getPopup(t);
    o && o.elPopupBody instanceof HTMLElement && o.recalcPosition();
  }
  /**
   * Скролл к активному элементу списка
   */
  static scrollToActive(t) {
    if (!DOM.querySelectorVisible(t, "ul.top-popup_content > li > .top-active"))
      return;
    const a = t.querySelector("ul.top-popup_content"), s = DOM.querySelectorAllVisible(t, "ul.top-popup_content > li");
    t.classList.add("top-popup-wrapper-no_animate"), setTimeout(() => t.classList.remove("top-popup-wrapper-no_animate"), 100);
    let p = 100;
    for (const e of s) {
      if (e.querySelector(":scope > .top-active"))
        break;
      e instanceof HTMLElement && (p += e.offsetHeight);
    }
    if (a instanceof HTMLElement) {
      const e = a.offsetHeight;
      p > e ? a.scrollTop = p - e : a.scrollTop = 0;
    }
  }
  static decoratorBeforeOpen(t) {
    this.options.decoratorBeforeOpen && this.options.decoratorBeforeOpen(t);
  }
  static decoratorAfterOpen(t) {
    this.options.decoratorAfterOpen && this.options.decoratorAfterOpen(t);
  }
  static decoratorIsIgnoreOuterClick(t) {
    return this.options.decoratorIsIgnoreOuterClick ? this.options.decoratorIsIgnoreOuterClick(t) : !1;
  }
  /**
   * Зарегистрировать Vue компонент
   *
   * Каждый экземляр Popup регистрируется в словаре vueConnectors для последующего доступа из js
   */
  static regVueComponent(t, o) {
    if (Worker.vueConnectors.get(t))
      throw "Vue component Popup use duplicated id: " + t;
    Worker.vueConnectors.set(t, o);
  }
  /**
   * Снять с регистрации Vue компонент
   */
  static unregVueComponent(t) {
    Worker.vueConnectors.delete(t);
  }
  /**
   * Сгенерировтаь элемент для открытия popup
   */
  static genElPopupOpener(t, o, ...a) {
    const s = DOM.genEl(t, {}, ...a);
    s.dataset.topPopup = "#" + o.id;
    for (let p in o) {
      const e = "topPopup" + p.charAt(0).toUpperCase() + p.slice(1);
      s.dataset[e] = o[p];
    }
    return s;
  }
}
export {
  Worker as TopPopupWorker
};
//# sourceMappingURL=worker.js.map
